/***************************************************************/
//
//
//		DirectX	[ fieldmap.h ]
//
//											Author	kazuki tanaka
//											Date	2017 5/29
/*---------------------------------------------------------------
Update : 2017/5/29
			Create Header File -> fieldmap.h.h 
 			< Add Class Function >
				FIELDMAP->Constructor
				FIELDMAP->Destructor
				FIELDMAP->Create ( static member )
				FIELDMAP->Init
				FIELDMAP->Uninit
				FIELDMAP->Update
				FIELDMAP->Draw

Update : 2017/5/29



/*-------------------------------------------------------------*/
#ifndef _FIELDMAP_H_

#define _FIELDMAP_H_


//#include "block.h"

#include "system_component.h"
#include "rendererdx9.h"

class GameObject;

#define GRID_FVF_FORMAT ( D3DFVF_XYZ | D3DFVF_DIFFUSE )

#define MAP_SIZE (5)


struct GridVertex
{
	D3DXVECTOR3 pos;
	D3DCOLOR    color;
};

/*---------------------------------------------------------------
	Class
---------------------------------------------------------------*/


// Class FieldMap Using FieldMap
class FieldMap
{
public:
	
	typedef enum{
		NONE = 0,
		IMMORTAL,
		MOVE,
		GOAL,
	}TYPE;
	
	FieldMap( );						// FieldMap Constructor
	~FieldMap( );						// FieldMap Destructor

	static FieldMap* Create( void );	// FieldMap Create Instance Class

	void Init( const char* filename = nullptr );	// FieldMap Initialize
	void Uninit( void );				// FieldMap Uninitialize
	void Update( void );				// FieldMap Update
	void Draw( void );					// FieldMap Draw

	static void SetObject( Vector3 pos, TYPE type, GameObject* pObj );
	void FieldCheck( void );
	static int* GetStatus( void );

	bool Scissor( const int& z, const int& x );
	bool OnScissor( const int& z, const int& x );

private:

	// Member Variable
	static FieldMap* pMap;
	LPDIRECT3DVERTEXBUFFER9 pVtxBuf;

	int vertical;
	int horizonal;
	
	int* map;							// map[][]ƂĎgp
	GameObject** pObj;

};


#endif	//	_FIELDMAP_H_


